/**
 * Copyright (c) 2015-2017 Obeo, Inria
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 	
 * Contributors:
 * - William Piers <william.piers@obeo.fr>
 * - Philippe Merle <philippe.merle@inria.fr>
 * - Faiez Zalila <faiez.zalila@inria.fr>
 */
package monitoring;

import org.modmacao.occi.platform.Application;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Sensor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Sensor Component
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link monitoring.Sensor#getOcciSensorTimebase <em>Occi Sensor Timebase</em>}</li>
 *   <li>{@link monitoring.Sensor#getOcciSensorTimestart <em>Occi Sensor Timestart</em>}</li>
 *   <li>{@link monitoring.Sensor#getOcciSensorTimestop <em>Occi Sensor Timestop</em>}</li>
 *   <li>{@link monitoring.Sensor#getOcciSensorPeriod <em>Occi Sensor Period</em>}</li>
 *   <li>{@link monitoring.Sensor#getOcciSensorGranularity <em>Occi Sensor Granularity</em>}</li>
 *   <li>{@link monitoring.Sensor#getOcciSensorAccuracy <em>Occi Sensor Accuracy</em>}</li>
 * </ul>
 *
 * @see monitoring.MonitoringPackage#getSensor()
 * @model
 * @generated
 */
public interface Sensor extends Application {
	/**
	 * Returns the value of the '<em><b>Occi Sensor Timebase</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Base time reference (ISO8601)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Sensor Timebase</em>' attribute.
	 * @see #setOcciSensorTimebase(String)
	 * @see monitoring.MonitoringPackage#getSensor_OcciSensorTimebase()
	 * @model dataType="monitoring.DateTime"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Sensor!occiSensorTimebase'"
	 * @generated
	 */
	String getOcciSensorTimebase();

	/**
	 * Sets the value of the '{@link monitoring.Sensor#getOcciSensorTimebase <em>Occi Sensor Timebase</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Sensor Timebase</em>' attribute.
	 * @see #getOcciSensorTimebase()
	 * @generated
	 */
	void setOcciSensorTimebase(String value);

	/**
	 * Returns the value of the '<em><b>Occi Sensor Timestart</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Start time offset (seconds)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Sensor Timestart</em>' attribute.
	 * @see #setOcciSensorTimestart(String)
	 * @see monitoring.MonitoringPackage#getSensor_OcciSensorTimestart()
	 * @model dataType="monitoring.Second"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Sensor!occiSensorTimestart'"
	 * @generated
	 */
	String getOcciSensorTimestart();

	/**
	 * Sets the value of the '{@link monitoring.Sensor#getOcciSensorTimestart <em>Occi Sensor Timestart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Sensor Timestart</em>' attribute.
	 * @see #getOcciSensorTimestart()
	 * @generated
	 */
	void setOcciSensorTimestart(String value);

	/**
	 * Returns the value of the '<em><b>Occi Sensor Timestop</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Sensor Timestop</em>' attribute.
	 * @see #setOcciSensorTimestop(String)
	 * @see monitoring.MonitoringPackage#getSensor_OcciSensorTimestop()
	 * @model dataType="monitoring.Second"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Sensor!occiSensorTimestop'"
	 * @generated
	 */
	String getOcciSensorTimestop();

	/**
	 * Sets the value of the '{@link monitoring.Sensor#getOcciSensorTimestop <em>Occi Sensor Timestop</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Sensor Timestop</em>' attribute.
	 * @see #getOcciSensorTimestop()
	 * @generated
	 */
	void setOcciSensorTimestop(String value);

	/**
	 * Returns the value of the '<em><b>Occi Sensor Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Time between two following measurements (seconds)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Sensor Period</em>' attribute.
	 * @see #setOcciSensorPeriod(String)
	 * @see monitoring.MonitoringPackage#getSensor_OcciSensorPeriod()
	 * @model dataType="monitoring.Second" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Sensor!occiSensorPeriod'"
	 * @generated
	 */
	String getOcciSensorPeriod();

	/**
	 * Sets the value of the '{@link monitoring.Sensor#getOcciSensorPeriod <em>Occi Sensor Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Sensor Period</em>' attribute.
	 * @see #getOcciSensorPeriod()
	 * @generated
	 */
	void setOcciSensorPeriod(String value);

	/**
	 * Returns the value of the '<em><b>Occi Sensor Granularity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Granularity of time measument (seconds)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Sensor Granularity</em>' attribute.
	 * @see #setOcciSensorGranularity(String)
	 * @see monitoring.MonitoringPackage#getSensor_OcciSensorGranularity()
	 * @model dataType="monitoring.Second"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Sensor!occiSensorGranularity'"
	 * @generated
	 */
	String getOcciSensorGranularity();

	/**
	 * Sets the value of the '{@link monitoring.Sensor#getOcciSensorGranularity <em>Occi Sensor Granularity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Sensor Granularity</em>' attribute.
	 * @see #getOcciSensorGranularity()
	 * @generated
	 */
	void setOcciSensorGranularity(String value);

	/**
	 * Returns the value of the '<em><b>Occi Sensor Accuracy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Accuracy of time measument (seconds)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Sensor Accuracy</em>' attribute.
	 * @see #setOcciSensorAccuracy(String)
	 * @see monitoring.MonitoringPackage#getSensor_OcciSensorAccuracy()
	 * @model dataType="monitoring.Second"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Sensor!occiSensorAccuracy'"
	 * @generated
	 */
	String getOcciSensorAccuracy();

	/**
	 * Sets the value of the '{@link monitoring.Sensor#getOcciSensorAccuracy <em>Occi Sensor Accuracy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Sensor Accuracy</em>' attribute.
	 * @see #getOcciSensorAccuracy()
	 * @generated
	 */
	void setOcciSensorAccuracy(String value);

} // Sensor
